
import java.util.*;

/*
   Exemplifies the Object reuse falacy .. Urn is a prior object which we
   tried to reuse .. with disastrous results .. well maybe not disastrous
*/

public class PuzzleSolver {

    /**
     *  The Puzzle to be solved
     */
    private Puzzle puzzle_;
    public Puzzle puzzle() { return puzzle_; }
    public void puzzle( Puzzle aPuzzle ) { puzzle_ = aPuzzle; }
    
    /**
     *  A source for random discreet random numbers
     */
    private Urn urn_;
    public Urn urn() { return urn_; }
    public void urn( Urn anUrn ) { urn_ = anUrn; }
    
    public PuzzleSolver() {
        this.initialize();
    }
    
    private void initialize() {
        int elementsPerSide = Configuration.instance().intValueOf("ELEMENTSPERSIDE");
        this.puzzle(new Puzzle());
        
        int totalElements = (elementsPerSide-1) * 4;
        this.urn(new Urn(25, (totalElements)*25, 25, totalElements));
        
        this.shuffleTheNumbers();
    }
    
    public void solveThePuzzle() {
        boolean done = false;
        while (!done) {
            this.shuffleTheNumbers();
            done = this.performTrial();
        }
        System.out.println("Done ..");
        this.puzzle().displaySides();
    }
    
            
    public boolean performTrial() {
        
        // save the first side total
        int firstValue = 0;
        Enumeration theOC = this.puzzle().sides().elements();
        Side aSide = (Side) theOC.nextElement();
        firstValue = aSide.totalValue();
        
        // now see if every other side total matches
        while(theOC.hasMoreElements()) {
            aSide = (Side) theOC.nextElement();
            if (aSide.totalValue() != firstValue) {
                return false;
            }
        }
        return true;
    }
    
    public void shuffleTheNumbers() {
        this.urn().reload();
        Enumeration theOC = this.puzzle().sideElementEnumerator();
        while (theOC.hasMoreElements()) {
            SideElement theSideElement = (SideElement) theOC.nextElement();
            theSideElement.value(this.urn().nextNumber());
        }
    }
}