
import java.util.*;

public class Side {

    /**
     *  The elemets associated with this Side
     */
    private Vector sideElements_;
    public Vector sideElements() { return sideElements_; }
    public void sideElements( Vector aVector ) { sideElements_ = aVector; }

    /**
     *  The name of this Side
     */
    private String name_;
    public String name() { return name_; }
    public void name( String aString ) { name_ = aString; }
    
    private Side() {
        this.initialize();
    }
    
    public Side(String name, Vector sideElements) {
        this();
        this.name(name);
        this.sideElements(sideElements);
    }
    
    private void initialize() {
        this.sideElements(new Vector());
    }
    
    public int totalValue() {
        int totalValue = 0;
        Enumeration theOC = this.sideElements().elements();
        while (theOC.hasMoreElements()) {
            int theValue = ((SideElement) theOC.nextElement()).value().intValue();
            totalValue += theValue;
        }
        return totalValue;
    }
    
    public String toString() {
        StringBuffer s = new StringBuffer();
        s.append(this.name());
        s.append(" - ");
        Enumeration theOC = this.sideElements().elements();
        while (theOC.hasMoreElements()) {
            s.append(((SideElement) theOC.nextElement()).value());
            s.append(" - ");
        }
        return s.toString();
    }
    
    public SideElement firstElement() {
        return (SideElement) this.sideElements().firstElement();
    }
    
    public SideElement lastElement() {
        return (SideElement) this.sideElements().lastElement();
    }
       
}